# -*- coding: utf-8 -*-

class SkuParser():
  supported_marketplaces = ['US', 'CA', 'MX', 'UK', 'DE', 'FR', 'IT', 'ES', 'JP', 'TR']

  @classmethod
  def parse(cls, sku):
    source = source_product_id = None
    sku_u = sku.upper().replace('-', '_')
    if sku_u.startswith('X01'):
      source = 'Rakuten'
      source_product_id = sku_u.split('_').pop()
    elif sku_u.startswith('X02'):
      source = 'Ebay_US'
      source_product_id = sku_u.split('_').pop()
    elif sku_u.startswith('X03'):
      source = 'Coupang'
      source_product_id = sku_u.split('_').pop()
    elif sku_u.startswith('X04'):
      source = 'AMZ_JP'
      source_product_id = sku_u.split('_').pop()
    elif sku_u.startswith('X05'):
      source = 'AMZ_UK'
      source_product_id = sku_u.split('_').pop()
    elif sku_u.startswith('X06'):
      source = 'AMZ_US'
      source_product_id = sku_u.split('_').pop()
    elif sku_u.startswith('AMZ_'):
      parts = sku_u.split('_')
      source_product_id = parts.pop()

      marketplace = None
      for part in parts:
        if part in cls.supported_marketplaces:
          marketplace = part
          break
      if not marketplace:
        marketplace = 'US'
      source = 'AMZ_{}'.format(marketplace)
    elif sku_u.startswith('EBAY_'):
      parts = sku_u.split('_')
      source_product_id = parts.pop()

      marketplace = None
      for part in parts:
        if part in cls.supported_marketplaces:
          marketplace = part
          break
      if not marketplace:
        marketplace = 'US'
      source = 'Ebay_{}'.format(marketplace)
    elif sku_u.startswith('COUPANG_'):
      source = "Coupang"
      parts = sku_u.split('_')
      source_product_id = parts.pop()
    elif sku_u.startswith('EM'):
      source = "EMP"
      source_product_id = sku
    else:
      source = 'Other'
      source_product_id = sku

    return (source, source_product_id)
